unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, IniFiles;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_iniParam, U_GYSListPB, U_KHList, U_GSList;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmGYSListPBGL, frmGYSListPBLR, frmGYSListPBChk, frmGYSListPBCX, frmGYSListPBGR: TfrmGYSListPB;
  frmGYSListPBGLKH, frmGYSListPBLRKH, frmGYSListPBChkKH, frmGYSListPBCXKH, frmGYSListPBGRKH: TfrmKHList;
  frmGSListGL, frmGSListCX: TfrmGSList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := GName;
  DCode := GName;
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '106.14.113.234,7781';
  dtbase := 'yunxiangdata';
  user := 'sa';
  pswd := 'rightsoft@123';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  DconString := DataBaseStr;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;
  if IsINIFile() then
    ReadINIFile()
  else
    WriteINIFile;
   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    1:  //客户信息录入(高)*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '客户信息录入(高)*' then
          begin
            BringWindowToTop(frmGYSListPBGLKH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGYSListPBGLKH := TfrmKHList.Create(application.MainForm);
          with frmGYSListPBGLKH do
          begin
            Title := '客户信息录入(高)*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGYSListPBGLKH.BringToFront;
       //句柄
        mnewHandle := frmGYSListPBGLKH.Handle;
      end;
    101:  //客户信息录入*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '客户信息录入*' then
          begin
            BringWindowToTop(frmGYSListPBLRKH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGYSListPBLRKH := TfrmKHList.Create(application.MainForm);
          with frmGYSListPBLRKH do
          begin
            Title := '客户信息录入*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGYSListPBLRKH.BringToFront;
       //句柄
        mnewHandle := frmGYSListPBLRKH.Handle;
      end;
    102:  //客户信息审核*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '客户信息审核*' then
          begin
            BringWindowToTop(frmGYSListPBChkKH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGYSListPBChkKH := TfrmKHList.Create(application.MainForm);
          with frmGYSListPBChkKH do
          begin
            Title := '客户信息审核*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGYSListPBChkKH.BringToFront;
       //句柄
        mnewHandle := frmGYSListPBChkKH.Handle;
      end;
    103:  //客户信息查询*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '客户信息查询*' then
          begin
            BringWindowToTop(frmGYSListPBCXKH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGYSListPBCXKH := TfrmKHList.Create(application.MainForm);
          with frmGYSListPBCXKH do
          begin
            Title := '客户信息查询*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGYSListPBCXKH.BringToFront;
       //句柄
        mnewHandle := frmGYSListPBCXKH.Handle;
      end;
    2:  //供应商信息录入(高)*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '供应商信息录入(高)*' then
          begin
            BringWindowToTop(frmGYSListPBGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGYSListPBGL := TfrmGYSListPB.Create(application.MainForm);
          with frmGYSListPBGL do
          begin
            Title := '供应商信息录入(高)*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGYSListPBGL.BringToFront;
       //句柄
        mnewHandle := frmGYSListPBGL.Handle;
      end;
    201:  //供应商信息录入*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '供应商信息录入*' then
          begin
            BringWindowToTop(frmGYSListPBLR.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGYSListPBLR := TfrmGYSListPB.Create(application.MainForm);
          with frmGYSListPBLR do
          begin
            Title := '供应商信息录入*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGYSListPBLR.BringToFront;
       //句柄
        mnewHandle := frmGYSListPBLR.Handle;
      end;
    202:  //供应商信息审核*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '供应商信息审核*' then
          begin
            BringWindowToTop(frmGYSListPBChk.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGYSListPBChk := TfrmGYSListPB.Create(application.MainForm);
          with frmGYSListPBChk do
          begin
            Title := '供应商信息审核*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGYSListPBChk.BringToFront;
       //句柄
        mnewHandle := frmGYSListPBChk.Handle;
      end;
    203:  //供应商信息查询*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '供应商信息查询*' then
          begin
            BringWindowToTop(frmGYSListPBCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGYSListPBCX := TfrmGYSListPB.Create(application.MainForm);
          with frmGYSListPBCX do
          begin
            Title := '供应商信息查询*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGYSListPBCX.BringToFront;
       //句柄
        mnewHandle := frmGYSListPBCX.Handle;
      end;
    3:  //公司账户资料管理*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '公司账户资料管理*' then
          begin
            BringWindowToTop(frmGSListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGSListGL := TfrmGSList.Create(application.MainForm);
          with frmGSListGL do
          begin
            Title := '公司账户资料管理*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGSListGL.BringToFront;
       //句柄
        mnewHandle := frmGSListGL.Handle;
      end;
    301:  //公司账户资料查询*
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '公司账户资料查询*' then
          begin
            BringWindowToTop(frmGSListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmGSListCX := TfrmGSList.Create(application.MainForm);
          with frmGSListCX do
          begin
            Title := '公司账户资料查询*';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmGSListCX.BringToFront;
       //句柄
        mnewHandle := frmGSListCX.Handle;
      end;

  end;  // end case
  Result := mnewHandle;
  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'SYSTEMSET.INI');
    PicSvr := IniFile.ReadString('SERVER', '服务器地址', '127.0.0.1');
    UserDataFlag := IniFile.ReadString('SERVER', '服务器地址类型', '-1');
  finally
    IniFile.Free;
  end;
  if not Assigned(DataLink_BaseInfoYX) then
    DataLink_BaseInfoYX := TDataLink_BaseInfoYX.Create(Application);
  try
    with DataLink_BaseInfoYX.ADOLink do
    begin
     // if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  OldDllApp := Application;


finalization
  DataLink_BaseInfoYX.Free;
  Application := OldDllApp;

end.

